// Runtime Class Trace
import java.awt.*;
import javax.swing.*;

public class ClassTrace extends JPanel {
	Button d;
	public ClassTrace()
	{
		d = new Button("Hello");
		add(d);
		printClass(d);
	}

	public void paintComponent( Graphics g )
	{
	      // call paintComponent to ensure the panel displays correctly
		super.paintComponent( g );
		int x = 10;
		int y = 80;
		Class c = d.getClass();
		while (c!=null) {
			g.drawString(c.getName(), x,y);
			x+=20;
			y+=15;
			c = c.getSuperclass();
		}
	}
		
	void printClass(Object obj) {
		Class c = obj.getClass();
		while (c!=null) {
			System.out.println(c.getName());
			c = c.getSuperclass();
		}
	}
	public static void main( String args[] )
	{
		// create a panel that contains our drawing
		ClassTrace panel = new ClassTrace();

		// create a new frame to hold the panel
		JFrame application = new JFrame("ClassTrace");

		// set the frame to exit when it is closed
		application.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );

		application.add( panel ); // add the panel to the frame      
		application.setSize( 250, 250 ); // set the size of the frame
		application.setVisible( true ); // make the frame visible

		int width = application.getWidth();
		int height = application.getHeight();
		System.out.printf("application width %d height %d\n",width,height);
	} 
}

